--
-- run from nas ao script (else uncomment login line)
--   - gethubs
--   - for each hub: getrobots
--   - for aech active robot callback to controller: port_list
--
-- Simple print of results
--


-- Get hub addresses into an array called hubs
function get_hubs()
	local hubs = {}
	local gethubs = nimbus.request("hub","gethubs")
	for row,hub in pairs(gethubs.hublist) do
		hubs[hub.name] = hub.addr
	end
	return hubs
end

-- Fetch a hub's robotlist into table "Robots" as: "robot name", "robot address"
function get_hub_robots(hub_address)
	local robots = {}
	getrobots, rc = nimbus.request(hub_address, "getrobots")
	if (rc ~= 0) then
		return "error"
	end
	
	for x, robot in pairs(getrobots.robotlist) do
		if (robot.status == 0) then
			robots[robot.name] = robot.addr
		end
		if (robot.status ~= 0) then
            	print("  * robot inactive: "..robot.name)
		end
	end
	return robots
end

-- Check probe_list feedback for missing hdb and spooler entries
function check_probe_list(hub, robot, robot_address)
	print("  robot: "..robot)
	local probes, rc = nimbus.request(robot_address.."/controller", "port_list")
	if rc == 0 then
		if (not probes["hdb"]) then
                print("  * no port found for hdb on robot: "..robot)
		end
		
		if (not probes["spooler"]) then
                print("  * no port found for spooler on robot: "..robot)
		end
	else
          print("  * could not get result for port_list for robot: "..robot)
	end
end

-- Main
--nimbus.login("administrator", "xxx")
local hubs = get_hubs()
for name, address in pairs(hubs) do
	print("Hub: "..name)
	local robots = get_hub_robots(address)
	if (robots == "error") then
		nimbus.alarm(4, name.." error getting robotlist", hub.."robotlist")
	else
		for robotname, robotaddress in pairs(robots) do
			check_probe_list(name, robotname, robotaddress)
		end
	end
end